/*
 * ToRegExpAlgebraic.cpp
 *
 *  Created on: 11. 2. 2014
 *	  Author: Tomas Pecka
 */

#include "ToRegExpAlgebraic.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace convert {

auto ToRegExpAlgebraicEpsilonNFA = registration::AbstractRegister < ToRegExpAlgebraic, regexp::UnboundedRegExp < >, const automaton::EpsilonNFA < > & > ( ToRegExpAlgebraic::convert, "automaton" ).setDocumentation (
"Performs the actual conversion.\n\
\n\
@param automaton The automaton that is to be converted to the regular expression\n\
@return regular expression equivalent to the input @p automaton" );

auto ToRegExpAlgebraicMultiInitialStateNFA = registration::AbstractRegister < ToRegExpAlgebraic, regexp::UnboundedRegExp < >, const automaton::MultiInitialStateNFA < > & > ( ToRegExpAlgebraic::convert, "automaton" ).setDocumentation (
"Performs the actual conversion.\n\
\n\
@param automaton The automaton that is to be converted to the regular expression\n\
@return regular expression equivalent to the input @p automaton" );

auto ToRegExpAlgebraicNFA = registration::AbstractRegister < ToRegExpAlgebraic, regexp::UnboundedRegExp < >, const automaton::NFA < > & > ( ToRegExpAlgebraic::convert, "automaton" ).setDocumentation (
"Performs the actual conversion.\n\
\n\
@param automaton The automaton that is to be converted to the regular expression\n\
@return regular expression equivalent to the input @p automaton" );

auto ToRegExpAlgebraicDFA = registration::AbstractRegister < ToRegExpAlgebraic, regexp::UnboundedRegExp < >, const automaton::DFA < > & > ( ToRegExpAlgebraic::convert, "automaton" ).setDocumentation (
"Performs the actual conversion.\n\
\n\
@param automaton The automaton that is to be converted to the regular expression\n\
@return regular expression equivalent to the input @p automaton" );

} /* namespace convert */

} /* namespace automaton */
