/*
 * InfiniteLanguage.cpp
 *
 *  Created on: 26. 3. 2019
 *	  Author: Tomas Pecka
 */

#include "InfiniteLanguage.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace properties {

auto InfiniteLanguageNFA = registration::AbstractRegister < InfiniteLanguage, bool, const automaton::NFA < > & > ( InfiniteLanguage::infinite, "fsm" ).setDocumentation (
"Determines whether input automaton accepts infinite language.\n\
\n\
@param fsm automaton\n\
@return bool" );

auto InfiniteLanguageDFA = registration::AbstractRegister < InfiniteLanguage, bool, const automaton::DFA < > & > ( InfiniteLanguage::infinite, "fsm" ).setDocumentation (
"Determines whether input automaton accepts infinite language.\n\
\n\
@param fsm automaton\n\
@return bool" );

} /* namespace properties */

} /* namespace automaton */

