/*
 * UsefulStates.cpp
 *
 *  Created on: 23. 3. 2014
 *	  Author: Tomas Pecka
 */

#include "UsefulStates.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace properties {

auto UsefulStatesEpsilonNFA = registration::AbstractRegister < UsefulStates, ext::set < DefaultStateType >, const automaton::EpsilonNFA < > & > ( UsefulStates::usefulStates, "fsm" ).setDocumentation (
"Finds all useful states of a finite automaton.\n\
Using closure implementation of the BFS algorithm.\n\
\n\
@param fsm automaton\n\
@return set of useful states of @p fsm" );

auto UsefulStatesNFA = registration::AbstractRegister < UsefulStates, ext::set < DefaultStateType >, const automaton::NFA < > & > ( UsefulStates::usefulStates, "fsm" ).setDocumentation (
"Finds all useful states of a finite automaton.\n\
Using closure implementation of the BFS algorithm.\n\
\n\
@param fsm automaton\n\
@return set of useful states of @p fsm" );

auto UsefulStatesCompactNFA = registration::AbstractRegister < UsefulStates, ext::set < DefaultStateType >, const automaton::CompactNFA < > & > ( UsefulStates::usefulStates, "fsm" ).setDocumentation (
"Finds all useful states of a finite automaton.\n\
Using closure implementation of the BFS algorithm.\n\
\n\
@param fsm automaton\n\
@return set of useful states of @p fsm" );

auto UsefulStatesExtendedNFA = registration::AbstractRegister < UsefulStates, ext::set < DefaultStateType >, const automaton::ExtendedNFA < > & > ( UsefulStates::usefulStates, "fsm" ).setDocumentation (
"Finds all useful states of a finite automaton.\n\
Using closure implementation of the BFS algorithm.\n\
\n\
@param fsm automaton\n\
@return set of useful states of @p fsm" );

auto UsefulStatesMultiInitialStateNFA = registration::AbstractRegister < UsefulStates, ext::set < DefaultStateType >, const automaton::MultiInitialStateNFA < > & > ( UsefulStates::usefulStates, "fsm" ).setDocumentation (
"Finds all useful states of a finite automaton.\n\
Using closure implementation of the BFS algorithm.\n\
\n\
@param fsm automaton\n\
@return set of useful states of @p fsm" );

auto UsefulStatesDFA = registration::AbstractRegister < UsefulStates, ext::set < DefaultStateType >, const automaton::DFA < > & > ( UsefulStates::usefulStates, "fsm" ).setDocumentation (
"Finds all useful states of a finite automaton.\n\
Using closure implementation of the BFS algorithm.\n\
\n\
@param fsm automaton\n\
@return set of useful states of @p fsm" );

auto UsefulStatesDFTA = registration::AbstractRegister < UsefulStates, ext::set < DefaultStateType >, const automaton::DFTA < > & > ( UsefulStates::usefulStates, "fta" ).setDocumentation (
"Finds all useful states of a finite tree automaton.\n\
Using closure implementation of the BFS algorithm.\n\
\n\
@param fta automaton\n\
@return set of useful states of @p fta" );

auto UsefulStatesNFTA = registration::AbstractRegister < UsefulStates, ext::set < DefaultStateType >, const automaton::NFTA < > & > ( UsefulStates::usefulStates, "fta" ).setDocumentation (
"Finds all useful states of a finite tree automaton.\n\
Using closure implementation of the BFS algorithm.\n\
\n\
@param fta automaton\n\
@return set of useful states of @p fta" );

} /* namespace properties */

} /* namespace automaton */

