/*
 * AutomatonIterationEpsilonTransition.cpp
 *
 *  Created on: 20. 11. 2014
 *	  Author: Tomas Pecka
 */

#include "AutomatonIterationEpsilonTransition.h"
#include <common/createUnique.hpp>
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace transform {

auto AutomatonIterationEpsilonTransitionDFA2 = registration::AbstractRegister < AutomatonIterationEpsilonTransition, automaton::EpsilonNFA < >, const automaton::DFA < > & > ( AutomatonIterationEpsilonTransition::iteration, "automaton" ).setDocumentation (
"Iteration of a finite automaton using epsilon transitions.\n\
\n\
@param automaton automaton to iterate\n\
@return nondeterministic FA representing the intersection of @p automaton" );

auto AutomatonIterationEpsilonTransitionNFA2 = registration::AbstractRegister < AutomatonIterationEpsilonTransition, automaton::EpsilonNFA < >, const automaton::NFA < > & > ( AutomatonIterationEpsilonTransition::iteration, "automaton" ).setDocumentation (
"Iteration of a finite automaton using epsilon transitions.\n\
\n\
@param automaton automaton to iterate\n\
@return nondeterministic FA representing the intersection of @p automaton" );

auto AutomatonIterationEpsilonTransitionEpsilonNFA2 = registration::AbstractRegister < AutomatonIterationEpsilonTransition, automaton::EpsilonNFA < >, const automaton::EpsilonNFA < > & > ( AutomatonIterationEpsilonTransition::iteration, "automaton" ).setDocumentation (
"Iteration of a finite automaton using epsilon transitions.\n\
\n\
@param automaton automaton to iterate\n\
@return nondeterministic FA representing the intersection of @p automaton" );

} /* namespace transform */

} /* namespace automaton */
